PROC PrintRecord()
PRIVATE Choice, Name, Line
  IF ISEMPTY("Ref") THEN
    MESSAGE "Data base is empty"
    RETURN
  ENDIF
  CURSOR NORMAL
  Name = GetFile("*.rpt", "Name:",
    "Enter name of file to print (without extension) or directory",
    Dir, FALSE)
  CURSOR OFF
  IF Name = "" THEN
    RETURN
  ENDIF
  IF ISFILE (Name + ".rpt") THEN
    SHOWMENU
      "Overwrite" : "Delete previous content of the file",
      "Append"    : "Add at the end of the file"
    TO Choice
    IF Choice = "Overwrite" THEN
      RUN "del " + Name + ".rpt"
    ENDIF
  ENDIF
  Dir = GetDir(Name)
  SHOWMENU
    "Everything"  : "to print all the fields",
    "Reference"   : "Flag, Authors, Name, Year, Source",
    "1-Reference" : "Flag, Authors, Name, Journal, year, v., N, p.,",
    "2-Reference" : "Flag, Authors, Journal, year, v., N, p.,",
    "3-Reference" : "Flag, Authors, Journal, v.(year)p."
  TO Choice
  SWITCH
    CASE Choice = "Everything"   : Everything()
    CASE Choice = "Reference"    : Reference()
    CASE Choice = "1-Reference"  : Reference1(TRUE, TRUE)
    CASE Choice = "2-Reference"  : Reference1(FALSE, TRUE)
    CASE Choice = "3-Reference"  : Reference1(FALSE, FALSE)
  ENDSWITCH
ENDPROC

PROC Everything()
  DO_IT!
  MOVETO TableMain
  SCAN
    Line = [Index] + ", " + STRVAL([Flag]) + ", " + [Year] + "\n"
    PRINT FILE Name + ".rpt" Line
    PrintTable("Ath", "Authors", FALSE)
    PrintTable("Ins", "Institute", FALSE)
    PrintTable("Nam", "Name", FALSE)
    PrintTable("Src", "Source", FALSE)
    PrintTable("Abs", "Abstract", FALSE)
    PrintTable("Key", "Keys", FALSE)
    PRINT FILE Name + ".rpt" "\n"
    MOVETO TableMain
    IF MOD(RECNO(), 5) = 0 THEN
      MESSAGE "Processing record " + STRVAL(RECNO())
    ENDIF
  ENDSCAN
  HOME
  COEDITKEY
ENDPROC

PROC PrintTable(NameTab, FieldN, PrintName)
PRIVATE i
  MOVETO NameTab
  IF NIMAGERECORDS() > 0 THEN
    MOVETO FIELD FieldN
    HOME
    IF PrintName THEN
      PRINT FILE Name + ".rpt" FieldN + "\n"
    ENDIF
    FOR i FROM 1 TO NIMAGERECORDS()
      Line = "  " + [] + "\n"
      PRINT FILE Name + ".rpt" Line
      IF NOT ATLAST() THEN
        DOWN
      ENDIF
    ENDFOR
  ENDIF
ENDPROC

PROC Reference()
  DO_IT!
  MOVETO TableMain
  SCAN
    PRINT FILE Name + ".rpt" STRVAL([Flag])
    PrintTable("Ath", "Authors", FALSE)
    PrintTable("Nam", "Name", FALSE)
    MOVETO TableMain
    PRINT FILE Name + ".rpt" "  " + [Year] + "\n"
    PrintTable("Src", "Source", FALSE)
    PRINT FILE Name + ".rpt" "\n"
    MOVETO TableMain
    IF MOD(RECNO(), 5) = 0 THEN
      MESSAGE "Processing record " + STRVAL(RECNO())
    ENDIF
  ENDSCAN
  HOME
  COEDITKEY
ENDPROC

PROC Reference1(IsName, IsFullSrc)
  IF NOT User THEN
    MESSAGE "Only for registered users, I'm sorry"
    SLEEP 1000
    RETURN
  ENDIF
  DO_IT!
  Buffer = ""
  MOVETO TableMain
  SCAN
    Choice = [Year]
;    IF NOT ISBLANK([Flag]) THEN
;      BufferPrint(STRVAL([Flag]) + ".")
;    ENDIF
    IF NOT ISBLANK([Index]) THEN
;      BufferPrint("[" + SUBSTR([Index], 1, 5) + SUBSTR([Index], 9, 1) + "].")
      GetCode(SUBSTR([Index], 1, 2))
    ENDIF
    PrintAuthors()
    IF IsName THEN
      PrintTable1("Nam", "Name")
    ENDIF
    PrintSource(IsFullSrc)
    PackBuffer()
    IF Buffer <> "" THEN
      PRINT FILE Name + ".rpt" Buffer + "\n\n"
    ENDIF
    Buffer = ""
    MOVETO TableMain
    IF MOD(RECNO(), 5) = 0 THEN
      MESSAGE "Processing record " + STRVAL(RECNO())
    ENDIF
  ENDSCAN
  HOME
  COEDITKEY
ENDPROC

PROC BufferPrint(String)
  IF LEN(Buffer) + LEN(String) > 255 THEN
    PackBuffer()
  ENDIF
  Buffer = Buffer + String
ENDPROC

PROC PackBuffer()
PRIVATE x
  WHILE LEN(Buffer) > 72
    x = 72
    IF SEARCH(" ", SUBSTR(Buffer, 1, x)) <> 0 THEN
      WHILE SUBSTR(Buffer, x, 1) <> " "
        x = x - 1
      ENDWHILE
    ENDIF
    PRINT FILE Name + ".rpt" SUBSTR(Buffer, 1, x) + "\n"
    Buffer = SUBSTR(Buffer, x + 1, LEN(Buffer) - x)
  ENDWHILE
ENDPROC

PROC GetCode(String)
PRIVATE i, j, l, a, l1, x, y, z, k
  MOVETO "Ath"
  IF NIMAGERECORDS() > 0 THEN
    MOVETO [Authors]
    HOME
;    FOR i FROM 1 TO NIMAGERECORDS()
      l = []
      l1 = ""
      k = 0
      RemoveSp(l)
      WHILE NOT ISBLANK(l)
        IF NOT MATCH(l, ".. ..", a, l) THEN
          a = l
          RemoveSp(a)
          l = ""
        ELSE
          RemoveSp(l)
        ENDIF
        k = k + 1
        IF NOT MATCH(a, "..-..", x, y) THEN
          x = a
          y = ""
        ENDIF
        IF k = 1 THEN
          IF SUBSTR(x, 2, 1) = "'" THEN
            y = SUBSTR(x, 3, 3)
          ELSE
            y = SUBSTR(x, 1, 3)
          ENDIF
          String = String + UPPER(y)
        ENDIF
        IF k = 2 THEN
          IF SUBSTR(x, 2, 1) = "'" THEN
            y = SUBSTR(x, 3, 3)
          ELSE
            y = SUBSTR(x, 1, 3)
          ENDIF
          String = String + "/" + UPPER(y)
        ENDIF
      ENDWHILE
;      IF NOT ATLAST() THEN
;        DOWN
;      ENDIF
;    ENDFOR
    BufferPrint(String + "   ")
  ELSE
    BufferPrint("___")
  ENDIF
ENDPROC

PROC PrintAuthors()
PRIVATE i, j, l, a, l1, x, y, z, k
  MOVETO "Ath"
  IF NIMAGERECORDS() > 0 THEN
    MOVETO [Authors]
    HOME
    k = 0
    FOR i FROM 1 TO NIMAGERECORDS()
      l = []
      l1 = ""
      RemoveSp(l)
      WHILE NOT ISBLANK(l)
        IF NOT MATCH(l, ".. ..", a, l) THEN
          a = l
          RemoveSp(a)
          l = ""
        ELSE
          RemoveSp(l)
        ENDIF
        k = k + 1
        IF NOT MATCH(a, "..-..", x, y) THEN
          x = a
          y = ""
        ENDIF
        a = ""
        FOR j FROM 1 TO LEN(y)
          a = a + SUBSTR(y, j, 1) + "."
        ENDFOR
        IF MATCH(x, ".._..", y, z) THEN
          x = y + "-" + z
        ENDIF
;        l1 = l1 + " " + a + " " + x + ","
; change for JPCRD
;        IF k < 4 THEN
          l1 = l1 + " " + x + ", " + a + ","
;        ELSE
;          IF k = 4 THEN
;            l1 = l1 + " et al.,"
;          ENDIF
;        ENDIF
      ENDWHILE
; for JPCRD
      IF ATLAST() THEN
        l1 = SUBSTR(l1, 1, LEN(l1) - 1) + "."
      ENDIF
      Line = l1
      BufferPrint(Line)
      IF NOT ATLAST() THEN
        DOWN
      ENDIF
    ENDFOR
  ENDIF
ENDPROC

PROC PrintTable1(NameTab, FieldN)
PRIVATE i
  MOVETO NameTab
  IF NIMAGERECORDS() > 0 THEN
    MOVETO FIELD FieldN
    HOME
    FOR i FROM 1 TO NIMAGERECORDS()
      IF ATLAST() AND NOT MATCH([],"..\.") THEN
        Line = " " + [] + "."
      ELSE
        Line = " " + []
      ENDIF
      BufferPrint(Line)
      IF NOT ATLAST() THEN
        DOWN
      ENDIF
    ENDFOR
  ENDIF
ENDPROC

PROC PrintSource(IsFullSrc)
PRIVATE i, iend, x, y, z, x1, y1, Vol, Num, Pp
  MOVETO TableName[5]
  IF NIMAGERECORDS() > 0 THEN
    MOVETO FIELD FieldName[7]
    END
    iend = [I]
    IF MATCH([], "..\;..", x, y) THEN
      WHILE MATCH(y, "..\;..", x1, y1)
        x = x + ";" + x1
        y = y1
      ENDWHILE
    ELSE
      z = []
      UP
      MOVETO FIELD FieldName[7]
      IF MATCH([], "..\;..", x, y) THEN
        iend = iend - 1
        WHILE MATCH(y, "..\;..", x1, y1)
          x = x + ";" + x1
          y = y1
        ENDWHILE
        y = y + z
      ELSE
        END
        x = []
        y = ""
      ENDIF
    ENDIF
    HOME
    FOR i FROM 0 TO iend
      IF i = iend THEN
        IF NOT MATCH(x, "..\.") THEN
;          Line = " " + x + "."
; 窠 ᫥  ୠ - ࠫ  JPCRD
          Line = " " + x
        ELSE
          Line = " " + x
        ENDIF
      ELSE
        Line = " " + []
      ENDIF
      BufferPrint(Line)
      IF NOT ATLAST() THEN
        DOWN
      ENDIF
    ENDFOR
    IF MATCH(y, "..\(..", x1, y1) THEN
      Vol = RemoveSp(x1)
      IF MATCH(y1, "..\)..", x, y) THEN
        Num = RemoveSp(x)
        Pp = y
      ELSE
        Num = ""
        Pp = y1
      ENDIF
    ELSE
      Vol = ""
      Num = ""
      Pp = y
    ENDIF
    Pp = RemoveSp(Pp)
    IF IsFullSrc THEN
      Line = " " + Choice
      IF Vol <> "" THEN
        Line = Line + ", v. " + Vol
      ENDIF
      IF Num <> "" THEN
        Line = Line + ", N " + Num
      ENDIF
      IF Pp <> "" THEN
        Line = Line + ", pp. " + Pp
      ENDIF
      IF NOT MATCH(Line, "..\.") THEN
        Line = Line + "."
      ENDIF
      BufferPrint(Line)
    ELSE
;      Line = " " + Vol + "(" + Choice + ")" + Pp
; for JPCRD
      IF NOT MATCH(Pp, "..-..", x, y) THEN
        x = Pp
      ENDIF
      Line = " " + Vol + ", " + x + ", (" + Choice + ")."
      BufferPrint(Line)
    ENDIF
  ELSE
    BufferPrint(" " + Choice + ".")
  ENDIF
ENDPROC

